Resent-Date: Fri, 6 Aug 1999 14:39:10 +0200 (MET DST)
To: linux-m68k@phil.uni-sb.de
Cc: scott@dmi.stevens-tech.edu, linux-m68k@lists.linux-m68k.org
Subject: Re: 2.2.x and 2.3.x
References: <199908041413.QAA13105@faui02q.informatik.uni-erlangen.de> <37A9DBF9.D77D688@gmx.de>
X-Yow: Three attractive BANK ROBBERS are discussing RELIGIOUS DIFFERENCES and
 MAKE-UP TECHNIQUE with them!!
From: Andreas Schwab <schwab@suse.de>
Date: 06 Aug 1999 14:39:01 +0200
In-Reply-To: Bernd Harries's message of "Thu, 05 Aug 1999 20:46:17 +0200"
User-Agent: Gnus/5.070095 (Pterodactyl Gnus v0.95) Emacs/20.4
Resent-From: linux-m68k@phil.uni-sb.de
Reply-To: linux-m68k@phil.uni-sb.de

Bernd Harries <bha@gmx.de> writes:

|> Then I made config and put atari_MFP statically into the kernel. SCC and
|> MIDI are still modules.
|> 
|> Now the unsatisfied symbols are gone. This appears strange to me.

The difference is that if all serial drivers are modules then the mid
layer (m68kserial.o) is also built as a module, and
arch/m68k/kernel/setup.o does not define register_serial any more (because
it's not needed).

Here is a patch for 2.2.10 which should fix the problem:

Index: arch/m68k/kernel/Makefile
===================================================================
RCS file: /usr/local/src/m68k-linux/cvsroot/linux/arch/m68k/kernel/Makefile,v
retrieving revision 1.1.1.1
diff -u -a -r1.1.1.1 Makefile
--- arch/m68k/kernel/Makefile	1999/08/02 15:35:16	1.1.1.1
+++ arch/m68k/kernel/Makefile	1999/08/06 11:39:16
@@ -13,8 +13,8 @@
 all: head.o kernel.o
 O_TARGET := kernel.o
 O_OBJS := entry.o process.o traps.o ints.o signal.o ptrace.o \
-	  setup.o sys_m68k.o time.o
-OX_OBJS := m68k_ksyms.o
+	  sys_m68k.o time.o
+OX_OBJS := setup.o m68k_ksyms.o
 
 ifdef CONFIG_KGDB
 O_OBJS += kgdb.o
Index: arch/m68k/kernel/m68k_ksyms.c
===================================================================
RCS file: /usr/local/src/m68k-linux/cvsroot/linux/arch/m68k/kernel/m68k_ksyms.c,v
retrieving revision 1.1.1.1
diff -u -a -r1.1.1.1 m68k_ksyms.c
--- arch/m68k/kernel/m68k_ksyms.c	1999/08/02 15:35:16	1.1.1.1
+++ arch/m68k/kernel/m68k_ksyms.c	1999/08/06 11:37:53
@@ -18,7 +18,6 @@
 #include <asm/checksum.h>
 #include <asm/hardirq.h>
 #include <asm/softirq.h>
-#include <asm/m68kserial.h>
 
 asmlinkage long long __ashrdi3 (long long, int);
 extern char m68k_debug_device[];
@@ -55,8 +54,6 @@
 EXPORT_SYMBOL(disable_irq);
 EXPORT_SYMBOL(kernel_set_cachemode);
 EXPORT_SYMBOL(kernel_thread);
-EXPORT_SYMBOL(register_serial);
-EXPORT_SYMBOL(unregister_serial);
 
 /* Networking helper routines. */
 EXPORT_SYMBOL(csum_partial_copy);
Index: arch/m68k/kernel/setup.c
===================================================================
RCS file: /usr/local/src/m68k-linux/cvsroot/linux/arch/m68k/kernel/setup.c,v
retrieving revision 1.1.1.1
diff -u -a -r1.1.1.1 setup.c
--- arch/m68k/kernel/setup.c	1999/08/02 15:35:16	1.1.1.1
+++ arch/m68k/kernel/setup.c	1999/08/06 11:52:54
@@ -19,6 +19,7 @@
 #include <linux/errno.h>
 #include <linux/string.h>
 #include <linux/init.h>
+#include <linux/module.h>
 
 #include <asm/bootinfo.h>
 #include <asm/setup.h>
@@ -452,6 +453,9 @@
   m68k_unregister_serial(i);
 #endif
 }
+EXPORT_SYMBOL(register_serial);
+EXPORT_SYMBOL(unregister_serial);
+
 #ifdef CONFIG_SERIAL_CONSOLE
 long serial_console_init(long kmem_start, long kmem_end)
 {


And here is another patch for 2.3.12 which is also broken:

Index: arch/m68k/kernel/Makefile
===================================================================
RCS file: /usr/local/src/m68k-linux/cvsroot/linux/arch/m68k/kernel/Makefile,v
retrieving revision 1.1.1.1
diff -u -a -r1.1.1.1 Makefile
--- arch/m68k/kernel/Makefile	1999/08/02 15:35:16	1.1.1.1
+++ arch/m68k/kernel/Makefile	1999/08/06 11:51:09
@@ -13,8 +13,8 @@
 all: head.o kernel.o
 O_TARGET := kernel.o
 O_OBJS := entry.o process.o traps.o ints.o signal.o ptrace.o \
-	  setup.o sys_m68k.o time.o
-OX_OBJS := m68k_ksyms.o
+	  sys_m68k.o time.o
+OX_OBJS := setup.o m68k_ksyms.o
 
 ifdef CONFIG_KGDB
 O_OBJS += kgdb.o
Index: arch/m68k/kernel/setup.c
===================================================================
RCS file: /usr/local/src/m68k-linux/cvsroot/linux/arch/m68k/kernel/setup.c,v
retrieving revision 1.1.1.3
diff -u -a -r1.1.1.3 setup.c
--- arch/m68k/kernel/setup.c	1999/08/03 07:53:59	1.1.1.3
+++ arch/m68k/kernel/setup.c	1999/08/06 11:52:54
@@ -19,6 +19,7 @@
 #include <linux/errno.h>
 #include <linux/string.h>
 #include <linux/init.h>
+#include <linux/module.h>
 
 #include <asm/bootinfo.h>
 #include <asm/setup.h>
@@ -452,6 +453,9 @@
   m68k_unregister_serial(i);
 #endif
 }
+EXPORT_SYMBOL(register_serial);
+EXPORT_SYMBOL(unregister_serial);
+
 #ifdef CONFIG_SERIAL_CONSOLE
 long serial_console_init(long kmem_start, long kmem_end)
 {


Andreas.

-- 
Andreas Schwab                                  "And now for something
schwab@suse.de                                   completely different."
SuSE GmbH, Schanzckerstr. 10, D-90443 Nrnberg

